import urllib

class SageAPI:

	_host = None
	_id = None
	_pwd = None
	_ssl = False
	_auth = None
	_enc = None

	def __init__(self, host = 'localhost', id = None, pwd = None, encoding = 'xml', ssl = False):
		self._host = host
		self._id = id
		self._pwd = pwd
		self._ssl = ssl
		self._enc = encoding

	def __getattr__(self, name):
		return _SagexHttpApi(name, self._host, self._id, self._pwd, self._enc, self._ssl)

class _SagexHttpApi:
	_name = None
	_host = None
	_id = None
	_pwd = None
	_ssl = None
	_enc = None

	def __init__(self, name, host, id, pwd, enc, ssl):
		self._name = name
		self._host = host
		self._id = id
		self._pwd = pwd
		self._enc = enc
		self._ssl = ssl

	def __call__(self, *args):
		url = 'http'
		if(self._ssl == True):
			url += 's'
		url += '://'
		if(self._id != None and self._pwd != None):
			url += self._id + ':' + self._pwd + '@'
		url += self._host + '/sagex/api?c=' + self._name
		for i in range(0, len(args)):
			url += '&' + str(i + 1) + '=' + urllib.quote_plus(str(args[i]))
		if(self._enc != 'xml'):
			url += '&encoder=' + self._enc
		resp = urllib.urlopen(url)
		return resp.read()